<?php add_thickbox(); ?>

<?php
// Check if there is postdata to know if we must update a record.
if (isset($_POST['postform']) && 'true' == $_POST['postform']) {
	global $wpdb;
	
	// Get the id of the record that needs to be updated.
	$recId = (int) $_POST['recid'];
	
	// Get the current data for this record saved in the database.
	$result = $wpdb->get_results("SELECT meta_id, meta_value FROM " . $wpdb->postmeta . " WHERE meta_key = 'cf7-adb-data' AND meta_id=" . $recId);
    $result = maybe_unserialize($result[0]->meta_value);				
	
	// Update the current dataset based on the filled in values.
	$currentDataset = $result;
	foreach($result as $key => $item) {
		if (isset($_POST[$key])) {
			$currentDataset[$key] = sanitize_text_field($_POST[$key]);
		}			
	}

	// Save the current dataset in the database.
	$currentDataset = maybe_serialize($currentDataset);
	$wpdb->update($wpdb->postmeta, array('meta_value' => $currentDataset), array("meta_id" => $recId), array('%s'), array('%d'));
}

/**
 * Get the id of the contact form id that is showed.
 *
 * @return int
 */
function getContactFormId() {
	if (isset($_GET['id']) && is_numeric($_GET['id'])) {
		return (int)$_GET['id'];
	} else {
		return 0;
	}
}

/**
 * @param string $string
 * @return string $html
 */
function renderFieldName($string) {
	$html = str_replace(array( '-','_' ), ' ', $string);
	$html = strtoupper($html);
	
	return $html;
}	

/**
 * Render a input field element.
 *
 * @param array $leadData
 * @param array $colKeysData
 * @return string $html;
 */
function renderFieldValue($leadData, $colKeysData) {
	if(is_array($leadData[$colKeysData])){
		foreach($leadData[$colKeysData] as $arrData){
			if ('created_date' == $colKeysData) {
				$dateTimestamp = strtotime($arrData);
				$html 		   = date('d-m-Y H:i', $dateTimestamp);		
			} else {				
				$html = '<input type="text" value="' . esc_attr($arrData) . '" id="' . esc_attr($colKeysData) . '" name="' . esc_attr($colKeysData) . '" />';
			}				
		} 
	}else{
		if ('created_date' == $colKeysData) {
			$dateTimestamp = strtotime($leadData[$colKeysData]);
			$html 		   = date('d-m-Y H:i', $dateTimestamp);		
		} else {					
			$html = '<input type="text" value="' . esc_attr($leadData[$colKeysData]) . '" id="' . esc_attr($colKeysData) . '" name="' . esc_attr($colKeysData) . '" />';
		}			
	}											
	
	return $html . '<br />';
}

/**
 * Remove obsolete array keys in $array and return it.
 *
 * @param array $array
 * @return array $array
 */
function cleanUpArray($array) {
	unset($array['_wpcf7'], 
		  $array['_wpcf7_version'], 
		  $array['_wpcf7_locale'], 
		  $array['_wpcf7_unit_tag'],
		  $array['_wpnonce'],
		  $array['_wpcf7_is_ajax_call']);

	return $array;
}	

/**
 * @return string $html;
 */
function renderFormSelector() {
	$cf7Selector = getContactFormId();
	$args = array(	'post_type'			=> 'wpcf7_contact_form',
					'posts_per_page'	=> -1,
					'orderby'			=> 'title',
					'order'				=> 'ASC');
	$cf7Query = new WP_Query( $args );
	if ( $cf7Query->have_posts() ) {
		$options = '';
		while ( $cf7Query->have_posts() ) {
			$cf7Query->the_post();
			
			$unread_messages = (int)get_post_meta( get_the_ID(), 'cf7-adb-data-unread', true );
			$selected_option = ($cf7Selector==get_the_ID()) ? 'selected' : '';
			$options .= '<option value="'.get_the_ID().'" ' . $selected_option . '>' . get_the_title() . ' (' . $unread_messages . ')</option>';
			
			if(0 == $cf7Selector){
				$cf7Selector = get_the_ID();
				$_GET['id']  = get_the_ID();
			}
		}
	}

	wp_reset_postdata(); 

	$html = '';            
	$html .= '<select id="cf7-selector">';  
	$html .= $options;          
	$html .= '</select>' . PHP_EOL;

	return $html;
}

?>
<div class="wrap">
	<h2>Contact Form Advanced Database</h2>
	 <div id="poststuff">        
		<?php 
		echo renderFormSelector();
		
		$colKeys = array();
		$cf7AdbArr = get_post_meta(getContactFormId(),'cf7-adb-data', true);
		if(!empty($cf7AdbArr)):	
			//clear unread messages on this contact form	
			update_post_meta( getContactFormId(), 'cf7-adb-data-unread', 0 );	
			?>
		
            <button class="button" id="adb-delete-button"><?php echo __( 'Delete rows', 'contact-form-advanced-database' ); ?></button>
            <a target="_blank"  class="button" id="adb-export" href="admin.php?page=cf7-adb-export-xls&id=<?php echo getContactFormId(); ?>"><?php echo __( 'Export XLS', 'contact-form-advanced-database' ); ?></a>
            <table class="wp-list-table widefat fixed media paginated" id="property-lead-table" data-page-length='10'>
                <thead>
                    <th class="manage-column column-cb check-column"></th>
                    <?php 
                    $cf7AdbArr = cleanUpArray($cf7AdbArr);
                    foreach(array_keys($cf7AdbArr) as $cf7AdbData) {
                        $colKeys[] = $cf7AdbData; ?>
                        <th class="manage-column column-title sorted">
                            <span><?php echo str_replace( array( '-','_' ), ' ', $cf7AdbData ); ?></span>				
                        </th>
                    <?php } ?>
                    <th></th>
                    <th></th>
                </thead>
    
                <tfoot>
                    <th class="manage-column column-cb check-column"></th>
                    <?php foreach(array_keys($cf7AdbArr) as $cf7AdbData) {?>
                        <th class="manage-column column-title sorted"><span><?php echo $cf7AdbData; ?></span></th>
                    <?php } ?>
                    <th></th>
                    <th></th>
                </tfoot>
                <tbody>
                    <?php                    
                    global $wpdb;
                    $result = $wpdb->get_results("SELECT meta_id, meta_value FROM " . $wpdb->postmeta . " WHERE meta_key = 'cf7-adb-data' AND post_id=" . getContactFormId());
                    foreach($result as $item){
                        $leadData  = maybe_unserialize($item->meta_value);				
                        $leadData  = cleanUpArray($leadData);
                                            
                        $colKeys 	= array_keys($cf7AdbArr);
                        $dataToPass = $leadData;	
                        $thDiv 		= rand(1,1000).'_'.time().'_'.rand(1000,5000);					
                        ?>
                        <tr>
                            <?php // Overview ?>
                            <td><input class="adb-chk" type="checkbox" data-status="0" data-id="<?php echo $item->meta_id; ?>" data-key="cf7-adb-data" value="<?php echo base64_encode(maybe_serialize($dataToPass)); ?>"></td>
                            <?php 
                            if(count($leadData) == count($colKeys)){
                                foreach($colKeys as $colKeysData){ ?>
                                    <td><?php 
                                    $stringToPrint = '';
                                    if(is_array($leadData[$colKeysData])){	
                                        foreach($leadData[$colKeysData] as $arrData){
                                            $stringToPrint .= ((filter_var($arrData, FILTER_VALIDATE_EMAIL))?'<a href="'.$arrData.'">'.$arrData.'</a>':$arrData).', ';	
                                        }
                                        echo rtrim($stringToPrint, ", ");
                                    }else{
                                        if(filter_var($leadData[$colKeysData], FILTER_VALIDATE_EMAIL)){
                                            echo '<a href="mailto:'.$leadData[$colKeysData].'">';
                                        }
                                        echo (strlen($leadData[$colKeysData]) > 60 )?substr($leadData[$colKeysData],0,60).'...':$leadData[$colKeysData]; 
                                        if(filter_var($leadData[$colKeysData], FILTER_VALIDATE_EMAIL)){
                                            echo '</a>';
                                        }
                                    }
                                    ?></td>
                            <?php } ?>
                            <?php }else{ 
                                    foreach(array_keys($leadData) as $leadDatas){ 
                                    $stringToPrint = '';
                                    if(is_array($leadData[$leadDatas])){	
                                        foreach($leadData[$leadDatas] as $arrData){
                                            $stringToPrint .= ((filter_var($arrData, FILTER_VALIDATE_EMAIL))?'<a href="'.$arrData.'">'.$arrData.'</a>':$arrData).', ';	
                                        }
                                        echo '<td><span class="edited-entries">'.$leadDatas.'</span><br />'.rtrim($stringToPrint, ", ").'</td>'; 
                                    }else{
                                        if(filter_var($leadData[$leadDatas], FILTER_VALIDATE_EMAIL)){
                                        echo '<td><span class="edited-entries">'.$leadDatas.'</span><br /><a href="mailto:'.$leadData[$leadDatas].'">'.((strlen($leadData[$leadDatas]) > 60 )?substr($leadData[$leadDatas],0,60).'...':$leadData[$leadDatas]).'</a></td>';
                                        }else{
                                            echo '<td><span class="edited-entries">'.$leadDatas.'</span><br />'.((strlen($leadData[$leadDatas]) > 60 )?substr($leadData[$leadDatas],0,60).'...':$leadData[$leadDatas]).'</td>';
                                        }
                                            
                                    }
                                }}	
    
                            ?>
                            <td>
                            <?php // Thickbox ?>
                            <div id="<?php echo $thDiv; ?>" style="display:none;">
                                <form id="adb_change_<?php echo $thDiv; ?>" method="post" enctype="multipart/form-data" action="<?php echo admin_url( 'admin.php?page=cf7-adb&id=' . getContactFormId());?>">
                                <input type="hidden" value="true" id="postform" name="postform" />
                                <input type="hidden" value="<?php echo $item->meta_id; ?>" id="recid" name="recid" />
                                <div>
                                      <?php if(count($leadData) == count($colKeys)){ ?>                                  
                                      <?php foreach($colKeys as $colKeysData){ ?>
                                            <div class="adb-per-line">
                                                <div class="field-name"><?php echo renderFieldName($colKeysData); ?></div>
                                                <div class="field-value"><?php echo renderFieldValue($leadData, $colKeysData); ?></div>
                                            </div>
                                         <?php } ?>
                                     <?php }else{ ?>
                                     <?php foreach(array_keys($leadData) as $leadDatas){ ?>
                                            <div class="adb-per-line">
                                                <div class="field-name"><?php echo renderFieldName($leadDatas); ?></div>
                                                <div class="field-value"><?php 
                                                    if(is_array($leadData[$leadDatas])){
                                                        foreach($leadData[$leadDatas] as $arrData){
                                                            echo $arrData . '<br />';
                                                        }
                                                    }else{
                                                        echo $leadData[$leadDatas] . '<br />';												
                                                    }
                                                ?></div>
                                            </div>
                                     
                                     <?php }}  ?>
                                     <input type="submit" class="adb-submit button" id="submit_<?php echo $thDiv; ?>" name="submit_<?php echo $thDiv; ?>" value="<?php echo __( 'Save', 'contact-form-advanced-database' ); ?>" />
                                 </div>
                                 </form>
                            </div>
                            
                            <a href="#TB_inline?width=600&height=550&inlineId=<?php echo $thDiv; ?>" title="<?php echo __( 'Contact Form fields and value', 'contact-form-advanced-database' ); ?>" class="view-button thickbox"><?php echo __( 'View', 'contact-form-advanced-database' ); ?></a></td>
                            <td><span class="del-button" data-id="<?php echo $item->meta_id; ?>" data-key="cf7-adb-data" data-val="<?php echo base64_encode(maybe_serialize($dataToPass)); ?>"><?php echo __( 'Delete', 'contact-form-advanced-database' ); ?></span></td>
                        </tr>
                    <?php } ?>
                </tbody>
            </table> 	
		<?php else: ?>
			<div id="no-data"><?php echo __( 'No Data Available', 'contact-form-advanced-database' ); ?></div>
		<?php endif; ?>	
		<div id="loading-panel">
			<img class="loader" src="<?php echo CF7ADBURL.'/lib/images/loader.gif' ?>" />
		</div>
	</div>
</div>